const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const drugGroupService = require('./drugGroup.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new drugGroup
 * @param {Object} req.body - The drugGroup data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created drugGroup
 */
function create(req, res, next) {
    drugGroupService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all drugGroups
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of drugGroups
 */
function getAll(req, res, next) {
    drugGroupService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of drugGroup objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of drugGroup objects
 */
function option(req, res, next) {
    drugGroupService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of drugGroups matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of drugGroups
 */
function count(req, res, next) {
    drugGroupService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing drugGroup
 * @param {number} req.params.id - The drugGroup ID to be updated
 * @param {Object} req.body - The drugGroup data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated drugGroup
 */
function update(req, res, next) {
    drugGroupService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a drugGroup
 * @param {number} req.params.id - The drugGroup ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    drugGroupService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
